# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.19-1.2911.6.5.fc6}

%define kmod_name rt2x00
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen
%define kdumpvar kdump
%endif
%ifarch i686 x86_64 ppc
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

%define cvs 20070311
%define debug_package %{nil}

Name:		%{kmod_name}-kmod
Version:	0.0.0cvs%cvs
Release:	1.%(echo %{kverrel} | tr - _)
Summary:	Kernel module for RT2x00 802.11 wireless devices 
Group:		System Environment/Kernel
License:	GPL
URL:		http://rt2x00.serialmonkey.com/
Source0:	http://rt2x00.serialmonkey.com/rt2x00-cvs-%{cvs}.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	sharutils
Requires:	rt2x00-kmod-common = %{version}
# Can be built on every arch. Confirm it...
# ExclusiveArch:	i586 i686 x86_64 ppc


%description
This package contains the Ralink rt2x00 Driver for WiFi, a linux
device driver for 802.11a/b/g universal NIC cards - either USB, Cardbus,
PCI or MiniPCI - that use rt2x00 chipsets.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c 
pushd %{kmod_name}-cvs-%{cvs}
## Build support for hardware button - commonly used ?
sed -i -e 's|CONFIG_RT2400PCI_BUTTON=n|CONFIG_RT2400PCI_BUTTON=y|' config
sed -i -e 's|CONFIG_RT2500PCI_BUTTON=n|CONFIG_RT2500PCI_BUTTON=y|' config
sed -i -e 's|CONFIG_RT61PCI_BUTTON=n|CONFIG_RT61PCI_BUTTON=y|' config
sed -i -e 's|CONFIG_RFKILL=n|CONFIG_RFKILL=y|' config
#sed -i -e 's|DEBUGFS=y|DEBUGFS=n|' config
#sed -i -e 's|CONFIG_CRC_ITU_T=y|CONFIG_CRC_ITU_T=n|' config
#sed -i -e 's|_ASM=n|_ASM=y|' config
#sed -i -e 's|INSTALL_MOD_DIR=rt2x00|INSTALL_MOD_DIR="../../../$(RPM_BUILD_ROOT)/lib/modules/%{kverrel}$(kvariant)/extra/%{kmod_name}"|' Makefile
## Don't need depmod -a with rpmbuild (kmodtool replaces it).
sed -i -e 's|/sbin/depmod -a||' Makefile 
popd


## Fix the #include <linux/config.h> - call deprecated since 2.6.18
# from Ville Skyttä - madwifi package.
#grep -rlF '<linux/config.h>' rt2x00-cvs-%{cvs} \
#| xargs sed -i -e 's|<linux/config.h>|<linux/autoconf.h>|'

for kvariant in %{kvariants} ; do
	cp -a rt2x00-cvs-%{cvs} _kmod_build_$kvariant
done

%build
for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
pushd _kmod_build_$kvariant
make	\
	KERNDIR="${ksrc}" 			\
	KERNELRELEASE=%{kverrel}${kvariant}
popd
done

%install
rm -rf $RPM_BUILD_ROOT

for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
pushd _kmod_build_$kvariant
#make	\
#	DESTDIR=$RPM_BUILD_ROOT				\
#	KERNELRELEASE=%{kverrel}${kvariant}		\
#	INSTALL_MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name} \
#install

install -D -m 0644 *.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}

popd
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
#rm -rf $RPM_BUILD_ROOT

%changelog
* Sun Mar  11 2007 kwizart < kwizart at gmail.com > - 0.0.0cvs20070311-1
- Update to 20070311

* Tue Mar  6 2007 kwizart < kwizart at gmail.com > - 0.0.0cvs20070306-1
- Update to 20070306

* Fri Mar  2 2007 kwizart < kwizart at gmail.com > - 0.0.0cvs20070302-1
- Update to 20070302

* Wed Feb 14 2007 kwizart < kwizart at gmail.com > - 0.0.0cvs20070214-1
- Update to 20070214

* Sat Jan 13 2007 kwizart < kwizart at gmail.com > - 0.0.0cvs20070113-1
- Update to 20070113

* Sat Dec 23 2006 kwizart w kwizart at gmail.com > - 0.0.0cvs20061223-1.fc6
- Update to 20061123
- fix variant error at insmod step

* Mon Nov 20 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20061120-1.fc6
- Update to 20061120.

* Fri Nov 10 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20061110-1.fc6
- Update to 20061110

* Wed Oct 25 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20061022-1_FC5
- Update to 20061022.
- split rt2x00 and d80211 

* Tue Oct 17 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20061017-1_FC5
- Update to 20061017.
- disable fedora-patch on kernel 2.6.18-1.2200.fc5
- fix: warning Including config.h is deprecated.

* Mon Oct 02 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20061002
- Update to cvs 20061002.
- Hardware button support.

* Tue Sep 13 2006 kwizart < kwizart at gmail.com > - 0.0.0cvs20060913_FC5
- inital release.
